#include <util/delay.h>
#include <i2c/i2cmaster.h>


struct PufferData {
	unsigned char dc;
	unsigned char len;
	unsigned char data;
	unsigned char bcc;
};


#define DISPLAY_WRITE	0xDE			// Display-Adresse zum Schreiben
#define DISPLAY_READ	0xDF			// Display-Adresse zum Lesen

#define NULL			0x00			// NULL
#define ACK				0x06
#define DC2				0x12			// 18(dez) Bezeichung fr DC2
#define S				0x53




unsigned char leseDaten() {
	char dataS[] = {S};
	unsigned char bccS, lenS = 1;
	unsigned char ackE = 0;
	struct PufferData dataE;

	i2c_init();

	// Initialisiere Struktur
	dataE.dc = NULL;
	dataE.len = NULL;
	dataE.data = NULL;
	dataE.bcc = NULL;

	// Prfsumme berechnen
	bccS  = DC2 + lenS + dataS[0];

	// Daten senden (d.h. sind Nutzdaten vorhanden?)
	i2c_start_wait(DISPLAY_WRITE+I2C_WRITE);						// setze Adresse vom Display und Schreib-Modus
	i2c_write(DC2);													// sende DC2
	i2c_write(lenS);												// sende Datenlnge
	i2c_write(dataS[0]);											// sende Nutzdaten
	i2c_write(bccS);												// sende Prf-Summe


	// Quittierung vom Display holen (lesen)
	i2c_rep_start(DISPLAY_WRITE+I2C_READ);							// setze Adresse vom Display und Lese-Modus

	_delay_us(100);
	ackE = i2c_readAck();											// Quittierung erfolgreich


	if(ackE == ACK) {												// Alles ok - Informationen lesen		
			
		dataE.dc = i2c_readAck();									// DC2 aus Empfangspuffer bekommen
		dataE.len = i2c_readAck();									// Lnge aus Empfangspuffer bekommen
		dataE.data = i2c_readAck();									// Anzahl abholbarer Bytes aus Empfangspuffer bekommen
		dataE.bcc = i2c_readAck();									// Prfsumme aus Empfangspuffer bekommen
	}

	i2c_stop();

	return 1;
}
